/******************************************************************************

   Copyright 1991 Lee Iverson

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose without fee is hereby granted without fee,
   provided that the above copyright notice appear in all copies and that
   both that copyright notice and this permission notice appear in
   supporting documentation, and that the name of McGill not be used in
   advertising or publicity pertaining to distribution of the software
   without specific, written prior permission.  McGill makes no
   representations about the suitability of this software for any purpose.
   It is provided "as is" without express or implied warranty.

   MCGILL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL MCGILL
   BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
   OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
   CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

   Author:
     Lee Iverson <leei@mcrcim.mcgill.edu>,
     McGill Research Centre for Intelligent Machines (McRCIM)

   $Id: BitImageP.h,v 0.9.1.2 1991/11/17 19:26:58 leei Exp $

******************************************************************************/

#ifndef _BitImageP_h_
#define _BitImageP_h_

#include <vim/BitImage.h>
#include <vim/GenImageP.h>

#include <vim/proto.h>

typedef struct _BitImageClassRec {
    GenericImageClassPart generic;
} BitImageClassRec;

#ifndef _byte
#define _byte
typedef unsigned char byte;
#endif

typedef struct {
    byte *data;
} BitImagePart;

typedef struct _BitImageRec {
    GenericImagePart generic;
    BitImagePart     bit;
} BitImageRec;

typedef struct {
    char dummy;
} BitDisplayParamsPart;

typedef struct _BitDisplayParamsRec {
    ExternalParams xparams;
    GenericDisplayParamsPart generic;
    BitDisplayParamsPart     bit;
} BitDisplayParamsRec;

#define declare_BitImage(pref)\
  unsigned short _CONCAT(pref,_width);\
  unsigned short _CONCAT(pref,_height);\
  byte *_CONCAT(pref,_data)

#define use_BitImage(im,pref)\
  unsigned short _CONCAT(pref,_width)  = (im)->generic.width;\
  unsigned short _CONCAT(pref,_height) = (im)->generic.height;\
  byte *_CONCAT(pref,_data)   = (im)->bit.data

#define access_BitImage(im,pref)\
  _CONCAT(pref,_width) = (im)->generic.width;\
  _CONCAT(pref,_height) = (im)->generic.height;\
  _CONCAT(pref,_data) = (im)->bit.data

#define end_BitImage(im,pref)\
  (im)->generic.width = _CONCAT(pref,_width);\
  (im)->generic.height = _CONCAT(pref,_height)

#endif /* _BitImageP_h_ */
