/******************************************************************************

   Copyright 1991 Lee Iverson

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose without fee is hereby granted without fee,
   provided that the above copyright notice appear in all copies and that
   both that copyright notice and this permission notice appear in
   supporting documentation, and that the name of McGill not be used in
   advertising or publicity pertaining to distribution of the software
   without specific, written prior permission.  McGill makes no
   representations about the suitability of this software for any purpose.
   It is provided "as is" without express or implied warranty.

   MCGILL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL MCGILL
   BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
   OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
   CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

   Author:
     Lee Iverson <leei@mcrcim.mcgill.edu>,
     McGill Research Centre for Intelligent Machines (McRCIM)

   $Id: ByteImage.h,v 0.9.1.2 1991/11/17 19:27:09 leei Exp $

******************************************************************************/

#ifndef _ByteImage_h_
#define _ByteImage_h_

#include <vim/proto.h>

#include <vim/GenImage.h>
#include <vim/RGBMap.h>
#include <vim/gamma.h>

#ifndef ImNdepth
#define ImNdepth "depth"
#define ImCDepth "Depth"
#endif

#ifndef ImNdata
#define ImNdata "data"
#endif

#ifndef ImCImageData
#define ImCImageData "ImageData"
#define ImRImageData "ImageData"
#endif

/* declare specific GenericImage class and instance datatypes */

#ifndef _byte
#define _byte
typedef unsigned char byte;
#endif

typedef struct _ByteImageClassRec*	ByteImageClass;
typedef struct _ByteImageRec*		ByteImage;
typedef struct _ByteDisplayParamsRec*	ByteDisplayParams;

/* declare the class constant */

extern ImageClass byteImageClass;

/* declare the externally visible function call interface. */

void
DisplayByteImage __((byte *im, int im_width, int im_height,
		     int dst_x, int dst_y,
		     ExternalParams *xparams, 
		     RGBMap *cmap, Pixel *index, 
		     float *intens, GammaParams *gamma,
		     Pixmap *pm_return, Dimension *pm_w, Dimension *pm_h));

#endif /* _ByteImage_h_ */
