/******************************************************************************

   Copyright 1991 Lee Iverson

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose without fee is hereby granted without fee,
   provided that the above copyright notice appear in all copies and that
   both that copyright notice and this permission notice appear in
   supporting documentation, and that the name of McGill not be used in
   advertising or publicity pertaining to distribution of the software
   without specific, written prior permission.  McGill makes no
   representations about the suitability of this software for any purpose.
   It is provided "as is" without express or implied warranty.

   MCGILL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL MCGILL
   BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
   OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
   CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

   Author:
     Lee Iverson <leei@mcrcim.mcgill.edu>,
     McGill Research Centre for Intelligent Machines (McRCIM)

   $Id: CMManage.h,v 0.9.1.1 1991/11/06 00:09:25 leei Exp $

******************************************************************************/

#ifndef _CMManage_h_
#define _CMManage_h_

#include <X11/Intrinsic.h>

#include <vim/proto.h>

#define XtCCMError "CMManageError"

extern Display      *CMdisplay;
extern Screen       *CMscreen;
extern Visual       *CMvisual;
extern Colormap      CMcmap;
extern unsigned int  CMdepth;
extern Pixel         CMblackPixel;
extern Pixel         CMwhitePixel;

#define DynamicVisual(vis)	((vis)->class & 1)

void
  CMInitialize __((Widget shell, int visual_class));
Status
  CMAllocColor __((XColor *color, int exact));
int
  CMAllocColors __((XColor *colors, int ncolors, int exact, int all));
Status
  CMAllocNamedColor __((char *name, XColor *screen_def, XColor *exact_def));

void
  CMFreeColor __((Pixel pixel));
void
  CMFreeColors __((Pixel *pixels, int npixels));

int 
  visualClassFromName __((char *name));
char *
  nameOfVisualClass __((int class));

#endif /* _CMManage_h_ */
