/******************************************************************************

   Copyright 1991 Lee Iverson

   Permission to use, copy, modify, and distribute this software and its
   documentation for any purpose without fee is hereby granted without fee,
   provided that the above copyright notice appear in all copies and that
   both that copyright notice and this permission notice appear in
   supporting documentation, and that the name of McGill not be used in
   advertising or publicity pertaining to distribution of the software
   without specific, written prior permission.  McGill makes no
   representations about the suitability of this software for any purpose.
   It is provided "as is" without express or implied warranty.

   MCGILL DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL
   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL MCGILL
   BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
   WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
   OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
   CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

   Author:
     Lee Iverson <leei@mcrcim.mcgill.edu>,
     McGill Research Centre for Intelligent Machines (McRCIM)

   $Id: proto.h,v 0.9.1.1 1991/11/06 00:09:25 leei Exp $

******************************************************************************/

#ifndef _proto_h_
#define _proto_h_

# ifdef __STDC__

#  ifndef __
#   define __(x) x
#  endif
#  ifndef _DCL
#   define _DCL(args, dcls) (dcls)
#   define _DCL_VOID (void)
#   define _IMPL(args, dcls) (dcls)
#   define _IMPL_VOID (void)
#   define _AND ,
#  endif

#  define _STRING(x) #x
#  define _CONCAT(x,y) x##y

#  define _SIGNED signed
#  define _CONST const

# else

#  ifndef __
#   define __(x) ()
#  endif
#  ifndef _DCL
#   define _DCL(args, dcls) ()
#   define _DCL_VOID ()
#   define _IMPL(args, dcls) args dcls;
#   define _IMPL_VOID ()
#   define _AND ;
#  endif

#  define _STRING(x) "x"
#  define _CONCAT(x,y) x/**/y

#  define _SIGNED
#  define _CONST

# endif /* __STDC__ */

#endif /* _proto_h_ */
