/*************************************************/
#ifndef lint
static char *sccs_id = "%W% %G% %U%%Z%";
static char *rcs_id = "$Header: /home/tectum/leei/image/vimage-0.9.3/RCS/rle_read.c,v 0.9.1.1 1991/12/16 18:11:05 leei Exp $";
#endif
/*---------------------------------------------*/

#include <vim/proto.h>
#include <vim/pFile.h>
#include "config.h"

#include <vim/ByteImageP.h>
#include <vim/RGBImageP.h>

#ifdef RLE

GenericImage rle_read _IMPL((in, ident), pFILE in _AND char *ident )
{
  Arg	argv[1];		Cardinal	argc;
  GenericImage		im = NULL;
  ByteImage		im_byt;
  RGBImage		im_rgb;
  int			im_width, im_height;		/* width, height */
  int		im_depth = 8 * sizeof( rle_pixel );	/* pixel depth */
  rle_pixel		**p_data;			/* scratch buffers */
  register RGBMap	*im_cmap;
  int			i0;
  int			im_y;
  rle_hdr		rle_im_hdr;
/*---------------------------------------------*/
  rle_im_hdr.rle_file = in->fp;
  rewind( in->fp );			/* start from beginning of file */
  {
    int		rle_err;

    if ( (rle_err = rle_get_setup( &rle_im_hdr )) < 0 ) 
      return ( (GenericImage)NULL );
  }
  im_width = rle_im_hdr.xmax - rle_im_hdr.xmin + 1,
  im_height = rle_im_hdr.ymax - rle_im_hdr.ymin + 1,
  argc = 0;
  XtSetArg( argv[argc], ImNdepth, im_depth );		++argc;

  /* only can handle RGB channels, so ignore the rest ... */
  RLE_CLR_BIT( rle_im_hdr, RLE_ALPHA );
  for ( i0 = 3; i0 < rle_im_hdr.ncolors; ++i0 )
    RLE_CLR_BIT( rle_im_hdr, i0 );

  p_data = (rle_pixel **) XtMalloc( rle_im_hdr.ncolors *
				   sizeof( rle_pixel *) );
  if ( rle_im_hdr.ncolors == 1 )
    im = ImCreateImage( ident, byteImageClass, im_width, im_height,
		       argv, argc );		/* pseudocolor ? */
  else
    im = ImCreateImage( ident, rgbImageClass, im_width, im_height,
		       argv, argc );		/* 24bit color ? */

/*---------------------------------------------*/
  if ( rle_im_hdr.ncolors == 1 )		/* pseudocolor ? */
  {
    im_byt = (ByteImage) im;
    p_data[ 0 ] = (rle_pixel *) ( im_byt->byte.data + ((im_height - 1) *
						       im_width) );
    while( (im_y = rle_getrow( &rle_im_hdr, p_data )) <= rle_im_hdr.ymax )
    {
      p_data[ 0 ] -= im_width;
    }	/*{ im_y }*/
  }
  else if ( rle_im_hdr.ncolors > 1 )
  {
    int				pix_siz, row_siz;
    byte			*p_rgb;
    register rle_pixel		*p_pix;
    register unsigned int	ncolors = rle_im_hdr.ncolors;

    im_rgb = (RGBImage) im;
    im_width = im_rgb->generic.width,
    pix_siz = im_rgb->rgb.pixlen;
    row_siz = pix_siz * 3 * im_width;
    p_rgb = im_rgb->rgb.data + ((im_height - 1) * row_siz);
    for ( i0 = 0; i0 < rle_im_hdr.ncolors; ++i0 )
      p_data[ i0 ] = (rle_pixel *) XtCalloc( im_width + 1,
					    sizeof( rle_pixel ) );

    while( (im_y = rle_getrow( &rle_im_hdr, p_data )) <= rle_im_hdr.ymax )
    {
      for ( p_pix = (rle_pixel *)p_rgb, i0 = 0; i0 < im_width; ++i0 )
      {
	*p_pix = *(p_data[ 0 ] + i0);
	++p_pix;
	if ( ncolors > 1 )
	  *p_pix = *(p_data[ 1 ] + i0);
	++p_pix;
	if ( ncolors > 2 )
	  *p_pix = *(p_data[ 2 ] + i0);
	++p_pix;
      }
      p_rgb -= row_siz;
    }	/*{ im_y }*/

    for ( i0 = 0; i0 < rle_im_hdr.ncolors; ++i0 )
      XtFree( (char *) p_data[ i0 ] );
  }	/*{ rle_im_hdr.ncolors }*/
/*---------------------------------------------*/
  /* local colormap */
  if ( rle_im_hdr.ncolors == 1 )
    im_cmap = &(((ByteImage) im)->byte.cmap);		/* pseudocolor ? */
  else
    im_cmap = &(((RGBImage) im)->rgb.cmap);		/* 24bit color ? */

  if ( im_cmap->size < 256 )		/* RGBImage may have no color map */
  {
    if ( im_cmap->size > 0 )
      freeRGBMapData( im_cmap );
    newRGBMapData( im_cmap, 256 );
  }
  if ( rle_im_hdr.ncmap > 0 )
  {
    register rle_map		*cmap;
    unsigned int	cmap_siz = (1 << rle_im_hdr.cmaplen);
    unsigned int	ncolors;

    if ( cmap_siz > 256 )
      ncolors = 256;
    else
      ncolors = cmap_siz;
    im_cmap->used = ncolors;
    if ( rle_im_hdr.ncmap == 3 )
      for ( i0 = 0; i0 < ncolors; ++i0 )
      {
	im_cmap->red[ i0 ]	= cmap[ i0 ];
	im_cmap->green[ i0 ]	= cmap[ i0 + cmap_siz ];
	im_cmap->blue[ i0 ]	= cmap[ i0 + cmap_siz + cmap_siz ];
      }		/*{ i0 lup }*/
    else
      for ( i0 = 0; i0 < ncolors; ++i0 )
      {
	im_cmap->red[ i0 ]	= cmap[ i0 ];
	if ( rle_im_hdr.ncmap > 1 )
	  im_cmap->green[ i0 ]	= cmap[ i0 + cmap_siz ];
	else
	  im_cmap->green[ i0 ]	= i0 << 8;

	if ( rle_im_hdr.ncmap > 2 )
	  im_cmap->blue[ i0 ]	= cmap[ i0 + cmap_siz + cmap_siz ];
	else
	  im_cmap->blue[ i0 ]	= i0 << 8;
      }		/*{ i0 lup }*/
  }
  else
  {
    register unsigned int	ncolors = 1 << im_depth;

    if ( rle_im_hdr.ncolors == 1 )
      im_cmap = &(((ByteImage) im)->byte.cmap);		/* pseudocolor ? */
    else
      im_cmap = &(((RGBImage) im)->rgb.cmap);		/* 24bit color ? */

    im_cmap->used = ncolors;
    for ( i0 = 0; i0 < ncolors; ++i0 )
    {
      im_cmap->red[ i0 ]	=
      im_cmap->green[ i0 ]	=
      im_cmap->blue[ i0 ]	= i0 << 8;
    }		/*{ i0 lup }*/
  }	/*{ ncmap > 0 ? }*/

  XtFree( (char *) p_data );
  return( (GenericImage)im );
}	/*{ rle_read() }*/

#endif	/* RLE */
